/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.rcsbusinessmessaging.v1.model;

/**
 * List of supported features by the user
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the RCS Business Messaging API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Capabilities extends com.google.api.client.json.GenericJson {

  /**
   * List of RBM features that this device supports.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> features;

  /**
   * This field is set by the RBM platform. The field resolves to "phones/{E.164}/capabilities",
   * where {E.164} is the user phone number in E.164 format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * List of RBM features that this device supports.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getFeatures() {
    return features;
  }

  /**
   * List of RBM features that this device supports.
   * @param features features or {@code null} for none
   */
  public Capabilities setFeatures(java.util.List<java.lang.String> features) {
    this.features = features;
    return this;
  }

  /**
   * This field is set by the RBM platform. The field resolves to "phones/{E.164}/capabilities",
   * where {E.164} is the user phone number in E.164 format.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * This field is set by the RBM platform. The field resolves to "phones/{E.164}/capabilities",
   * where {E.164} is the user phone number in E.164 format.
   * @param name name or {@code null} for none
   */
  public Capabilities setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public Capabilities set(String fieldName, Object value) {
    return (Capabilities) super.set(fieldName, value);
  }

  @Override
  public Capabilities clone() {
    return (Capabilities) super.clone();
  }

}
